# Application

All application endpoints

## GET /v3/application

> Get all your applications and their main details

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Application":{"type":"object","required":["id","type","managementProtocol","name","createdAt","inUse"],"properties":{"id":{"type":"string","format":"","description":"Application ID","readOnly":true},"type":{"type":"integer","format":"integer","description":"The list of application type can be found in: GET /application/type"},"managementProtocol":{"type":"integer","format":"integer","description":"The protocol used to manage the application (defaults to None when not set):\n* 0: None\n* 1: A2S\n* 2: ARCUS"},"name":{"type":"string","format":"","description":"The public name of your application"},"websiteUrl":{"type":"string","format":"","description":"The url to your application's website"},"description":{"type":"string","format":"","description":"A short description of your application"},"developerName":{"type":"string","format":"","description":"The name of the application's developer"},"publisherName":{"type":"string","format":"","description":"The name of the application's publisher"},"stopDefaultOsGroup":{"type":"integer","format":"integer","description":"The default operating system group being used for the stop method. If you have a Windows and Linux ApplicationBuild you can overwrite this on the ApplicationBuild level. Must be one of:\n* 1: Windows\n* 2: Linux (default)"},"stopMethod":{"type":"integer","format":"integer","description":"The stop method that will be used on restart or destroy of an application instance. The default is hard kill, list of types can be found in: [GET /v3/application/stopMethod](game-publisher#/Application/getApplicationStopMethods)"},"stopTimeout":{"type":"integer","format":"integer","description":"The timeout that will be used on restart or destroy of an application instance, in seconds. The default is 0 (no timeout)"},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"If the application currently in use or not","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application":{"get":{"tags":["Application"],"summary":"Get all your applications and their main details","operationId":"getApplications","parameters":[{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA:start=0,results=25","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Application"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## POST /v3/application

> Create an application

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Application":{"type":"object","required":["id","type","managementProtocol","name","createdAt","inUse"],"properties":{"id":{"type":"string","format":"","description":"Application ID","readOnly":true},"type":{"type":"integer","format":"integer","description":"The list of application type can be found in: GET /application/type"},"managementProtocol":{"type":"integer","format":"integer","description":"The protocol used to manage the application (defaults to None when not set):\n* 0: None\n* 1: A2S\n* 2: ARCUS"},"name":{"type":"string","format":"","description":"The public name of your application"},"websiteUrl":{"type":"string","format":"","description":"The url to your application's website"},"description":{"type":"string","format":"","description":"A short description of your application"},"developerName":{"type":"string","format":"","description":"The name of the application's developer"},"publisherName":{"type":"string","format":"","description":"The name of the application's publisher"},"stopDefaultOsGroup":{"type":"integer","format":"integer","description":"The default operating system group being used for the stop method. If you have a Windows and Linux ApplicationBuild you can overwrite this on the ApplicationBuild level. Must be one of:\n* 1: Windows\n* 2: Linux (default)"},"stopMethod":{"type":"integer","format":"integer","description":"The stop method that will be used on restart or destroy of an application instance. The default is hard kill, list of types can be found in: [GET /v3/application/stopMethod](game-publisher#/Application/getApplicationStopMethods)"},"stopTimeout":{"type":"integer","format":"integer","description":"The timeout that will be used on restart or destroy of an application instance, in seconds. The default is 0 (no timeout)"},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"If the application currently in use or not","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application":{"post":{"tags":["Application"],"summary":"Create an application","operationId":"createApplication","requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Application"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Application"}}}}},"403":{"description":"Invalid credentials"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/{applicationId}

> Get the details of the given application

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Application":{"type":"object","required":["id","type","managementProtocol","name","createdAt","inUse"],"properties":{"id":{"type":"string","format":"","description":"Application ID","readOnly":true},"type":{"type":"integer","format":"integer","description":"The list of application type can be found in: GET /application/type"},"managementProtocol":{"type":"integer","format":"integer","description":"The protocol used to manage the application (defaults to None when not set):\n* 0: None\n* 1: A2S\n* 2: ARCUS"},"name":{"type":"string","format":"","description":"The public name of your application"},"websiteUrl":{"type":"string","format":"","description":"The url to your application's website"},"description":{"type":"string","format":"","description":"A short description of your application"},"developerName":{"type":"string","format":"","description":"The name of the application's developer"},"publisherName":{"type":"string","format":"","description":"The name of the application's publisher"},"stopDefaultOsGroup":{"type":"integer","format":"integer","description":"The default operating system group being used for the stop method. If you have a Windows and Linux ApplicationBuild you can overwrite this on the ApplicationBuild level. Must be one of:\n* 1: Windows\n* 2: Linux (default)"},"stopMethod":{"type":"integer","format":"integer","description":"The stop method that will be used on restart or destroy of an application instance. The default is hard kill, list of types can be found in: [GET /v3/application/stopMethod](game-publisher#/Application/getApplicationStopMethods)"},"stopTimeout":{"type":"integer","format":"integer","description":"The timeout that will be used on restart or destroy of an application instance, in seconds. The default is 0 (no timeout)"},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"If the application currently in use or not","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}":{"get":{"tags":["Application"],"summary":"Get the details of the given application","operationId":"getApplication","parameters":[{"name":"applicationId","in":"path","description":"The Id of the application for which to fetch the information","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Application"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/application/{applicationId}

> Update a application's mutable properties

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Application":{"type":"object","required":["id","type","managementProtocol","name","createdAt","inUse"],"properties":{"id":{"type":"string","format":"","description":"Application ID","readOnly":true},"type":{"type":"integer","format":"integer","description":"The list of application type can be found in: GET /application/type"},"managementProtocol":{"type":"integer","format":"integer","description":"The protocol used to manage the application (defaults to None when not set):\n* 0: None\n* 1: A2S\n* 2: ARCUS"},"name":{"type":"string","format":"","description":"The public name of your application"},"websiteUrl":{"type":"string","format":"","description":"The url to your application's website"},"description":{"type":"string","format":"","description":"A short description of your application"},"developerName":{"type":"string","format":"","description":"The name of the application's developer"},"publisherName":{"type":"string","format":"","description":"The name of the application's publisher"},"stopDefaultOsGroup":{"type":"integer","format":"integer","description":"The default operating system group being used for the stop method. If you have a Windows and Linux ApplicationBuild you can overwrite this on the ApplicationBuild level. Must be one of:\n* 1: Windows\n* 2: Linux (default)"},"stopMethod":{"type":"integer","format":"integer","description":"The stop method that will be used on restart or destroy of an application instance. The default is hard kill, list of types can be found in: [GET /v3/application/stopMethod](game-publisher#/Application/getApplicationStopMethods)"},"stopTimeout":{"type":"integer","format":"integer","description":"The timeout that will be used on restart or destroy of an application instance, in seconds. The default is 0 (no timeout)"},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"If the application currently in use or not","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}":{"put":{"tags":["Application"],"summary":"Update a application's mutable properties","operationId":"updateApplication","parameters":[{"name":"applicationId","in":"path","description":"The Id of the application to update","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Application"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Application"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"405":{"description":"Application type can not be changed"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## DELETE /v3/application/{applicationId}

> Delete a given application

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}":{"delete":{"tags":["Application"],"summary":"Delete a given application","operationId":"deleteApplication","parameters":[{"name":"applicationId","in":"path","description":"The Id of the application to delete","required":true,"schema":{"type":"string"}}],"responses":{"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"409":{"description":"Application is in use"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/type

> Get the list of available application types.

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationType":{"type":"object","required":["typeId","typeDescription"],"properties":{"typeId":{"type":"integer","format":"integer","description":"Application type ID","readOnly":true},"typeDescription":{"type":"string","format":"","description":"Application type description","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/type":{"get":{"tags":["Application"],"summary":"Get the list of available application types.","operationId":"getApplicationTypes","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationType"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/{applicationId}/install

> Get all the installs of an application

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationInstall":{"type":"object","required":["id","applicationId","applicationType","createdAt","name","version","osGroupId","active","filePath","fileSize","fileSHA256","executableSHA256","status","installHasExe"],"properties":{"id":{"type":"integer","format":"integer","description":"Application install ID","readOnly":true},"applicationId":{"type":"string","format":"","description":"Application install assigned to applicationId"},"applicationType":{"type":"integer","format":"integer","description":"The list of Application types can be found in: GET /application/type","nullable":true},"createdAt":{"type":"integer","format":"integer","description":"Application install created at timestamp","readOnly":true},"name":{"type":"string","format":"","description":"Application install name"},"version":{"type":"string","format":"","description":"Application install version"},"osGroupId":{"type":"integer","format":"integer","description":"Operating system group ID (1 = windows, 2 = linux)"},"active":{"type":"integer","format":"integer","description":"Application install active"},"releaseNotes":{"type":"string","format":"","description":"Application install release notes","nullable":true},"filePath":{"type":"string","format":"","description":"Path of the file on the file server","readOnly":true},"fileSize":{"type":"integer","format":"integer","description":"File size in bytes","readOnly":true},"fileSHA256":{"type":"string","format":"","description":"Archive file SHA-256 hash","readOnly":true},"executableSHA256":{"type":"string","format":"","description":"SHA-256 hash of the executable in the archive","readOnly":true},"status":{"type":"integer","format":"integer","description":"Status of application install.","readOnly":true},"installHasExe":{"type":"integer","format":"integer","description":"Does the archive contain the game instance executable?"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/install":{"get":{"deprecated":true,"tags":["Application"],"summary":"Get all the installs of an application","operationId":"getApplicationInstallsByApplicationId","parameters":[{"name":"applicationId","in":"path","description":"The Id of the application for which to fetch the installs","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationInstall"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/{applicationId}/applicationBuild

> Get all the application builds created for the given application

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationBuild":{"type":"object","required":["id","name","applicationId","type","executable","osId","createdAt","runAsRoot"],"properties":{"id":{"type":"string","format":"","description":"Application build ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the application build"},"applicationId":{"type":"string","format":"","description":"The ID of the application. May be null if buildProvisioningStorageType is LegacyFTP","nullable":true},"hostCapacityTemplateId":{"type":"string","format":"","description":"The ID of the host capacity template"},"type":{"type":"integer","format":"integer","description":"The application build, list of types can be found in: [GET /application/type](#/Application/get_v3_application_type)","readOnly":true},"executable":{"type":"string","format":"","description":"The executable name including the path originating from the root directory of the software structure"},"startupParameters":{"type":"string","format":"","description":"The startup parameters required for an executable"},"instanceDoesReadyCallback":{"type":"integer","format":"integer","description":"Set to 1 if a deployed application instance will inform the platform it's done with initializing and is ready to\naccept players. Defaults to 0 if not set, which means an instance's status will go directly to ONLINE (4) after starting"},"installId":{"type":"integer","format":"integer","description":"ID of the application install (legacy FTP, will be removed, may not be updated)","deprecated":true},"osId":{"type":"integer","format":"integer","description":"ID of the operating system, list of operating systems can be found in: [GET\n/v3/operatingsystem](all#/OperatingSystem/get_v3_operatingsystem)"},"stopMethod":{"type":"integer","format":"integer","description":"The stop method that will be used on restart or destroy of an application instance. The default is taken from the value of\n[GET /v3/application/stopMethod](game-publisher#/Application/getApplicationStopMethods) - any value submitted here overrides that Application default","nullable":true},"stopTimeout":{"type":"integer","format":"integer","description":"The timeout that will be used on restart or destroy of an application instance. The default is taken from the value of\n`Application.stopTimeout` - any value submitted here overrides that Application default","nullable":true},"createdAt":{"type":"integer","format":"integer","description":"When the application build was created (unix timestamp)","readOnly":true},"label":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Custom key/value pairs that can be used for application build selection / identification"},"applicationBuildFile":{"allOf":[{"$ref":"#/components/schemas/ApplicationBuildFile"}],"description":"The application build file to be used for the application instance","nullable":true},"buildProvisioningStorageType":{"type":"integer","format":"integer","description":"Type of storage being used [GET\n/v3/buildProvisioning/storage/registration/types](#/BuildProvisioning/getBuildProvisioningStorageRegistrationTypes). Default: 0"},"runAsRoot":{"type":"integer","format":"integer","description":"Controls whether to run this build as root or as a non-privileged user.\nWarning: This currently only works for builds deployed onto a Linux operating system. Windows builds will always run as administrator\n* 0: run as non-privileged user\n* 1: run as root user (default)"}},"additionalProperties":false},"Label":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Label key, only hyphens (-), underscores (_), lowercase characters and numbers are allowed. Keys must start with a lowercase character."},"value":{"type":"string","format":"","description":"Label value, maximum length is 150 characters"}},"additionalProperties":false},"ApplicationBuildFile":{"type":"object","required":["id","buildProvisioningFileId","buildProvisioningRegistrationId","fileName","fileSize","version","md5CheckSum","createdAt","changedAt","availableOnCDN"],"properties":{"id":{"type":"string","format":"","description":"Application build file ID","readOnly":true},"buildProvisioningFileId":{"type":"string","format":"","description":"ID of the uploaded file to the i3D.net storage. Cannot be updated once set"},"buildProvisioningRegistrationId":{"type":"string","format":"","description":"ID of the build provisioning registration. Cannot be updated once set"},"fileName":{"type":"string","format":"","description":"Name of the file"},"fileSize":{"type":"integer","format":"integer","description":"Size of the file","readOnly":true},"version":{"type":"string","format":"","description":"Version of the file"},"md5CheckSum":{"type":"string","format":"","description":"MD5 checksum of the file","readOnly":true},"path":{"type":"string","format":"","description":"location of the file"},"domain":{"type":"string","format":"","description":"The domain where the files are stored"},"dockerRepository":{"type":"string","format":"","description":"The docker repository that needs to be used","deprecated":true},"createdAt":{"type":"integer","format":"integer","description":"UNIX timestamp when the application build file has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"UNIX timestamp when the application build file last has been changed","readOnly":true},"availableOnCDN":{"type":"integer","format":"integer","description":"the file is on the CDN when is 1.","readOnly":true}},"additionalProperties":false,"nullable":true},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/applicationBuild":{"get":{"tags":["Application"],"summary":"Get all the application builds created for the given application","operationId":"getApplicationApplicationBuilds","parameters":[{"name":"labels","in":"query","description":"Label expressions can be used to apply more specific search parameters and can be written in standard SQL query language.<br />\nE.g. `region_id=123` or multiple filters: `region_id=123 and fleet_id=456 or host_id=46256` The provided filter query needs to be url encoded. E.g.<br />\n`region_id%3D123` or multiple filters: `region_id%3D123%20and%20fleet_id%3D456%20or%20host_id%3D46256` The total would look like:<br />\n`/application/{applicationId}/applicationBuild?labels=region_id%3D123%20and%20fleet_id%3D456%20or%20host_id%3D46256`<br />\nIf you want to filter on a non-numeric label such as `region_name`, you have to wrap the value in double quotes: `region_name=\"Rotterdam\"`.<br />\nFor more information about labels check <a href=\"https://www.i3d.net/docs/one/odp/Platform-Elements/Application/Label/#pre-defined-labels\">details</a>","schema":{"type":"string"}},{"name":"applicationId","in":"path","description":"The Id of the application for which to fetch the application builds","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationBuild"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"422":{"description":"Labels error"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/{applicationId}/applicationBuild/inUse

> Get all the application builds which have application instances created for the given application

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationBuild":{"type":"object","required":["id","name","applicationId","type","executable","osId","createdAt","runAsRoot"],"properties":{"id":{"type":"string","format":"","description":"Application build ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the application build"},"applicationId":{"type":"string","format":"","description":"The ID of the application. May be null if buildProvisioningStorageType is LegacyFTP","nullable":true},"hostCapacityTemplateId":{"type":"string","format":"","description":"The ID of the host capacity template"},"type":{"type":"integer","format":"integer","description":"The application build, list of types can be found in: [GET /application/type](#/Application/get_v3_application_type)","readOnly":true},"executable":{"type":"string","format":"","description":"The executable name including the path originating from the root directory of the software structure"},"startupParameters":{"type":"string","format":"","description":"The startup parameters required for an executable"},"instanceDoesReadyCallback":{"type":"integer","format":"integer","description":"Set to 1 if a deployed application instance will inform the platform it's done with initializing and is ready to\naccept players. Defaults to 0 if not set, which means an instance's status will go directly to ONLINE (4) after starting"},"installId":{"type":"integer","format":"integer","description":"ID of the application install (legacy FTP, will be removed, may not be updated)","deprecated":true},"osId":{"type":"integer","format":"integer","description":"ID of the operating system, list of operating systems can be found in: [GET\n/v3/operatingsystem](all#/OperatingSystem/get_v3_operatingsystem)"},"stopMethod":{"type":"integer","format":"integer","description":"The stop method that will be used on restart or destroy of an application instance. The default is taken from the value of\n[GET /v3/application/stopMethod](game-publisher#/Application/getApplicationStopMethods) - any value submitted here overrides that Application default","nullable":true},"stopTimeout":{"type":"integer","format":"integer","description":"The timeout that will be used on restart or destroy of an application instance. The default is taken from the value of\n`Application.stopTimeout` - any value submitted here overrides that Application default","nullable":true},"createdAt":{"type":"integer","format":"integer","description":"When the application build was created (unix timestamp)","readOnly":true},"label":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Custom key/value pairs that can be used for application build selection / identification"},"applicationBuildFile":{"allOf":[{"$ref":"#/components/schemas/ApplicationBuildFile"}],"description":"The application build file to be used for the application instance","nullable":true},"buildProvisioningStorageType":{"type":"integer","format":"integer","description":"Type of storage being used [GET\n/v3/buildProvisioning/storage/registration/types](#/BuildProvisioning/getBuildProvisioningStorageRegistrationTypes). Default: 0"},"runAsRoot":{"type":"integer","format":"integer","description":"Controls whether to run this build as root or as a non-privileged user.\nWarning: This currently only works for builds deployed onto a Linux operating system. Windows builds will always run as administrator\n* 0: run as non-privileged user\n* 1: run as root user (default)"}},"additionalProperties":false},"Label":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Label key, only hyphens (-), underscores (_), lowercase characters and numbers are allowed. Keys must start with a lowercase character."},"value":{"type":"string","format":"","description":"Label value, maximum length is 150 characters"}},"additionalProperties":false},"ApplicationBuildFile":{"type":"object","required":["id","buildProvisioningFileId","buildProvisioningRegistrationId","fileName","fileSize","version","md5CheckSum","createdAt","changedAt","availableOnCDN"],"properties":{"id":{"type":"string","format":"","description":"Application build file ID","readOnly":true},"buildProvisioningFileId":{"type":"string","format":"","description":"ID of the uploaded file to the i3D.net storage. Cannot be updated once set"},"buildProvisioningRegistrationId":{"type":"string","format":"","description":"ID of the build provisioning registration. Cannot be updated once set"},"fileName":{"type":"string","format":"","description":"Name of the file"},"fileSize":{"type":"integer","format":"integer","description":"Size of the file","readOnly":true},"version":{"type":"string","format":"","description":"Version of the file"},"md5CheckSum":{"type":"string","format":"","description":"MD5 checksum of the file","readOnly":true},"path":{"type":"string","format":"","description":"location of the file"},"domain":{"type":"string","format":"","description":"The domain where the files are stored"},"dockerRepository":{"type":"string","format":"","description":"The docker repository that needs to be used","deprecated":true},"createdAt":{"type":"integer","format":"integer","description":"UNIX timestamp when the application build file has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"UNIX timestamp when the application build file last has been changed","readOnly":true},"availableOnCDN":{"type":"integer","format":"integer","description":"the file is on the CDN when is 1.","readOnly":true}},"additionalProperties":false,"nullable":true},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/applicationBuild/inUse":{"get":{"tags":["Application"],"summary":"Get all the application builds which have application instances created for the given application","operationId":"getApplicationApplicationBuildInUses","parameters":[{"name":"applicationId","in":"path","description":"The Id of the application for which to fetch the application builds","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationBuild"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"422":{"description":"Labels error"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/stopMethod

> Get stop methods of an application

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationOSStopMethods":{"type":"object","required":["linux","windows"],"properties":{"linux":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationStopMethod"},"description":"Stop methods for Linux.","readOnly":true},"windows":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationStopMethod"},"description":"Stop methods for Windows.","readOnly":true}},"additionalProperties":false},"ApplicationStopMethod":{"type":"object","required":["id","description"],"properties":{"id":{"type":"integer","format":"integer","description":"Stop method identifier","readOnly":true},"description":{"type":"string","format":"","description":"Stop method identifier","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/stopMethod":{"get":{"tags":["Application"],"summary":"Get stop methods of an application","operationId":"getApplicationStopMethods","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationOSStopMethods"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/{applicationId}/deploymentEnvironment

> Get the list of deployment environment using given applicationId

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentEnvironment":{"type":"object","required":["id","name","createdAt"],"properties":{"id":{"type":"string","format":"","description":"Deployment environment ID","readOnly":true},"name":{"type":"string","format":"","description":"The public name of your deployment environment"},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/deploymentEnvironment":{"get":{"tags":["Application"],"summary":"Get the list of deployment environment using given applicationId","operationId":"getApplicationDeploymentEnvironments","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentEnvironment"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/{applicationId}/fleet

> Get the list of fleets using given applicationId

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Fleet":{"type":"object","required":["id","name","deploymentEnvironmentId","operationalStatus","isGameLift"],"properties":{"id":{"type":"string","format":"","description":"Fleet ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the fleet"},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID to which the fleet is assigned"},"deploymentProfileId":{"type":"string","format":"","description":"The `DeploymentProfileTemplate`'s ID, used for scaling, that is attached to this `Fleet`"},"gameDeploymentTemplateId":{"type":"string","format":"","description":"The `GameDeploymentTemplate`'s ID that is attached to this `Fleet`"},"utilityDeploymentTemplateId":{"type":"string","format":"","description":"The `UtilityDeploymentTemplate`'s ID that is attached to this `Fleet`"},"dependencyDeploymentTemplateId":{"type":"string","format":"","description":"The `DependencyDeploymentTemplate`'s ID that is attached to this `Fleet`"},"hostCapacityTemplateId":{"type":"string","format":"","description":"The `HostCapacityTemplate`'s ID that is attached to this `Fleet`"},"operationalStatus":{"type":"integer","format":"integer","description":"0: Manual, 1: Automatic deployment enabled, 2: Automatic scaling enabled (implies automatic deployment)","readOnly":true},"isGameLift":{"type":"boolean","description":"When it is active it cannot be disabled anymore"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/fleet":{"get":{"tags":["Application"],"summary":"Get the list of fleets using given applicationId","operationId":"getApplicationFleets","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Fleet"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/{applicationId}/deploymentTemplate

> Get a list of deployment templates for a given applicationId

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"GameDeploymentTemplate":{"type":"object","required":["id","fleetIds","name","inUse","createdAt","gameDeploymentTemplateBuild"],"properties":{"id":{"type":"string","format":"","description":"Game deployment template ID","readOnly":true},"fleetIds":{"type":"array","items":{"type":"string","format":""},"description":"IDs of the fleets that use this template","readOnly":true},"name":{"type":"string","format":"","description":"The public name of your game deployment template"},"inUse":{"type":"integer","format":"integer","description":"Indicates whether this game deployment template is used by one or more fleets. A template cannot be deleted as long as this value is 1.","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true},"gameDeploymentTemplateBuild":{"type":"array","items":{"$ref":"#/components/schemas/GameDeploymentTemplateBuild"},"description":"Application build assigned to the template (can only be one build)"}},"additionalProperties":false},"GameDeploymentTemplateBuild":{"type":"object","required":["applicationBuildId"],"properties":{"applicationBuildId":{"type":"string","format":"","description":"The Application Build ID"}},"additionalProperties":false},"UtilityDeploymentTemplate":{"type":"object","required":["id","fleetIds","name","inUse","createdAt","utilityDeploymentTemplateBuild"],"properties":{"id":{"type":"string","format":"","description":"Utility deployment template ID","readOnly":true},"fleetIds":{"type":"array","items":{"type":"string","format":""},"description":"IDs of the fleets that use this template","readOnly":true},"name":{"type":"string","format":"","description":"The name of your utility deployment template"},"inUse":{"type":"integer","format":"integer","description":"Indicates whether this utility deployment template is used by one or more fleets. A template cannot be deleted as long as this value is 1.","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true},"utilityDeploymentTemplateBuild":{"type":"array","items":{"$ref":"#/components/schemas/UtilityDeploymentTemplateBuild"},"description":"A List of utility deployment template build's"}},"additionalProperties":false},"UtilityDeploymentTemplateBuild":{"type":"object","required":["applicationBuildId"],"properties":{"applicationBuildId":{"type":"string","format":"","description":"The Application Build ID"},"deployOn":{"type":"integer","format":"integer","description":"Indicates on which host types to install the utilities on:\n1) bare metal,\n2) VM,\n3) both (default value when not specified)"},"installsPerLocation":{"type":"integer","format":"integer","description":"If > 0, limit the amount of deploys on hosts to this figure, for each active dcLocation.\nSo if this value is 2, this utility will only be deployed on two hosts per dcLocation. If 0 (default value when not specified), it will be deployed on every host in use."}},"additionalProperties":false},"DependencyDeploymentTemplate":{"type":"object","required":["id","name","dependencyInstallerBuildId","dependencyUninstallerBuildId","fleetIds","inUse","createdAt"],"properties":{"id":{"type":"string","format":"","description":"dependency Deployment template ID","readOnly":true},"name":{"type":"string","format":"","description":"Name of the dependency deployment template"},"dependencyInstallerBuildId":{"type":"string","format":"","description":"Dependency installer build ID"},"dependencyUninstallerBuildId":{"type":"string","format":"","description":"Dependency uninstaller build ID"},"fleetIds":{"type":"array","items":{"type":"string","format":""},"description":"IDs of the fleets that use this template","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"Indicates whether this dependency deployment template is used by one or more fleets. A template cannot be deleted as long as this value is 1.","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/deploymentTemplate":{"get":{"tags":["Application"],"summary":"Get a list of deployment templates for a given applicationId","operationId":"getApplicationDeploymentTemplates","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"oneOf":[{"$ref":"#/components/schemas/GameDeploymentTemplate"},{"$ref":"#/components/schemas/UtilityDeploymentTemplate"},{"$ref":"#/components/schemas/DependencyDeploymentTemplate"}]}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/{applicationId}/property

> Get all your application properties for given applicationId

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationProperty":{"type":"object","required":["id","propertyType","propertyKey"],"properties":{"id":{"type":"string","format":"","description":"The application property ID","readOnly":true},"propertyType":{"type":"integer","format":"integer","description":"The application property type. For a list of application property types see\n[`GET /v3/application/property/type`](#/Application/get_v3_application_property_type)"},"propertyKey":{"type":"string","format":"","description":"The application property key. Only hyphens (-), underscores (_), lowercase characters and numbers are allowed.\nKeys must start with a lowercase character"},"propertyValue":{"type":"string","format":"","description":"The application property value"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/property":{"get":{"tags":["Application"],"summary":"Get all your application properties for given applicationId","operationId":"getApplicationProperties","parameters":[{"name":"applicationId","in":"path","description":"The Id of the application for which to fetch the properties","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationProperty"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## POST /v3/application/{applicationId}/property

> Create a property of given applicationId

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationProperty":{"type":"object","required":["id","propertyType","propertyKey"],"properties":{"id":{"type":"string","format":"","description":"The application property ID","readOnly":true},"propertyType":{"type":"integer","format":"integer","description":"The application property type. For a list of application property types see\n[`GET /v3/application/property/type`](#/Application/get_v3_application_property_type)"},"propertyKey":{"type":"string","format":"","description":"The application property key. Only hyphens (-), underscores (_), lowercase characters and numbers are allowed.\nKeys must start with a lowercase character"},"propertyValue":{"type":"string","format":"","description":"The application property value"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/property":{"post":{"tags":["Application"],"summary":"Create a property of given applicationId","operationId":"createApplicationProperty","parameters":[{"name":"applicationId","in":"path","description":"The Id of the application for which the property will be created","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApplicationProperty"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationProperty"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId"},"409":{"description":"Network port is already in use by another network port property"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/{applicationId}/property/{propertyId}

> Get the property for given applicationId and given propertyId

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationProperty":{"type":"object","required":["id","propertyType","propertyKey"],"properties":{"id":{"type":"string","format":"","description":"The application property ID","readOnly":true},"propertyType":{"type":"integer","format":"integer","description":"The application property type. For a list of application property types see\n[`GET /v3/application/property/type`](#/Application/get_v3_application_property_type)"},"propertyKey":{"type":"string","format":"","description":"The application property key. Only hyphens (-), underscores (_), lowercase characters and numbers are allowed.\nKeys must start with a lowercase character"},"propertyValue":{"type":"string","format":"","description":"The application property value"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/property/{propertyId}":{"get":{"tags":["Application"],"summary":"Get the property for given applicationId and given propertyId","operationId":"getApplicationProperty","parameters":[{"name":"applicationId","in":"path","description":"The Id of the application the property belongs to","required":true,"schema":{"type":"string"}},{"name":"propertyId","in":"path","description":"Id of the property to fetch","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationProperty"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId or propertyId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/application/{applicationId}/property/{propertyId}

> Update the given property of given applicationId

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationProperty":{"type":"object","required":["id","propertyType","propertyKey"],"properties":{"id":{"type":"string","format":"","description":"The application property ID","readOnly":true},"propertyType":{"type":"integer","format":"integer","description":"The application property type. For a list of application property types see\n[`GET /v3/application/property/type`](#/Application/get_v3_application_property_type)"},"propertyKey":{"type":"string","format":"","description":"The application property key. Only hyphens (-), underscores (_), lowercase characters and numbers are allowed.\nKeys must start with a lowercase character"},"propertyValue":{"type":"string","format":"","description":"The application property value"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/property/{propertyId}":{"put":{"tags":["Application"],"summary":"Update the given property of given applicationId","operationId":"updateApplicationProperty","parameters":[{"name":"applicationId","in":"path","description":"The Id of the application the property belongs to","required":true,"schema":{"type":"string"}},{"name":"propertyId","in":"path","description":"The Id of the property to update","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApplicationProperty"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationProperty"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId or propertyId"},"409":{"description":"Network port is already in use by another network port property"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## DELETE /v3/application/{applicationId}/property/{propertyId}

> Delete the given property of the applicationId

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/{applicationId}/property/{propertyId}":{"delete":{"tags":["Application"],"summary":"Delete the given property of the applicationId","operationId":"deleteApplicationProperty","parameters":[{"name":"applicationId","in":"path","description":"The Id of the application for which to delete the property","required":true,"schema":{"type":"string"}},{"name":"propertyId","in":"path","description":"Property Id to delete","required":true,"schema":{"type":"string"}}],"responses":{"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid applicationId or propertyId"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/application/property/type

> Get a list of all the possible application property types

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"Application","description":"All application endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationPropertyType":{"type":"object","required":["typeId","typeDescription"],"properties":{"typeId":{"type":"integer","format":"integer","description":"Application type ID","readOnly":true},"typeDescription":{"type":"string","format":"","description":"Application type description","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/application/property/type":{"get":{"tags":["Application"],"summary":"Get a list of all the possible application property types","operationId":"getApplicationPropertyTypes","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationPropertyType"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.i3d.net/api-references/game/application.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
